diff --git a/src/backend/replication/logical/origin.c b/src/backend/replication/logical/origin.c
index 13808a4674b..45d3b18d31f 100644
--- a/src/backend/replication/logical/origin.c
+++ b/src/backend/replication/logical/origin.c
@@ -315,8 +315,8 @@ replorigin_create(const char *roname)
 
 	for (roident = InvalidOid + 1; roident < PG_UINT16_MAX; roident++)
 	{
-		bool		nulls[Natts_pg_replication_origin];
-		Datum		values[Natts_pg_replication_origin];
+		Datum		values[Natts_pg_replication_origin] = {0};
+		bool		nulls[Natts_pg_replication_origin] = {false};
 		bool		collides;
 
 		CHECK_FOR_INTERRUPTS();
@@ -343,11 +343,11 @@ replorigin_create(const char *roname)
 			 */
 			memset(&nulls, 0, sizeof(nulls));
 
-			values[Anum_pg_replication_origin_roident - 1] = ObjectIdGetDatum(roident);
-			values[Anum_pg_replication_origin_roname - 1] = roname_d;
+			HeapTupleSetValue(pg_replication_origin, roident, ObjectIdGetDatum(roident), values);
+			HeapTupleSetValue(pg_replication_origin, roname, roname_d, values);
 
 			tuple = heap_form_tuple(RelationGetDescr(rel), values, nulls);
-			CatalogTupleInsert(rel, tuple);
+			CatalogTupleInsert(rel, tuple, NULL);
 			CommandCounterIncrement();
 			break;
 		}
diff --git a/src/backend/replication/logical/tablesync.c b/src/backend/replication/logical/tablesync.c
index 67e57520386..e9cffb6d246 100644
--- a/src/backend/replication/logical/tablesync.c
+++ b/src/backend/replication/logical/tablesync.c
@@ -1650,9 +1650,9 @@ UpdateTwoPhaseState(Oid suboid, char new_state)
 {
 	Relation	rel;
 	HeapTuple	tup;
-	bool		nulls[Natts_pg_subscription];
-	bool		replaces[Natts_pg_subscription];
-	Datum		values[Natts_pg_subscription];
+	Datum		values[Natts_pg_subscription] = {0};
+	bool		nulls[Natts_pg_subscription] = {false};
+	Bitmapset  *updated = NULL;
 
 	Assert(new_state == LOGICALREP_TWOPHASE_STATE_DISABLED ||
 		   new_state == LOGICALREP_TWOPHASE_STATE_PENDING ||
@@ -1665,19 +1665,13 @@ UpdateTwoPhaseState(Oid suboid, char new_state)
 			 "cache lookup failed for subscription oid %u",
 			 suboid);
 
-	/* Form a new tuple. */
-	memset(values, 0, sizeof(values));
-	memset(nulls, false, sizeof(nulls));
-	memset(replaces, false, sizeof(replaces));
-
 	/* And update/set two_phase state */
-	values[Anum_pg_subscription_subtwophasestate - 1] = CharGetDatum(new_state);
-	replaces[Anum_pg_subscription_subtwophasestate - 1] = true;
+	HeapTupleUpdateValue(pg_subscription, subtwophasestate, CharGetDatum(new_state), values, nulls, updated);
 
-	tup = heap_modify_tuple(tup, RelationGetDescr(rel),
-							values, nulls, replaces);
-	CatalogTupleUpdate(rel, &tup->t_self, tup);
+	tup = heap_update_tuple(tup, RelationGetDescr(rel), values, nulls, updated);
+	CatalogTupleUpdate(rel, &tup->t_self, tup, updated, NULL);
 
-	heap_freetuple(tup);
 	table_close(rel, RowExclusiveLock);
+	bms_free(updated);
+	heap_freetuple(tup);
 }
diff --git a/src/backend/replication/logical/worker.c b/src/backend/replication/logical/worker.c
index ad281e7069b..7efd77fba27 100644
--- a/src/backend/replication/logical/worker.c
+++ b/src/backend/replication/logical/worker.c
@@ -6125,21 +6125,12 @@ clear_subscription_skip_lsn(XLogRecPtr finish_lsn)
 	 */
 	if (subform->subskiplsn == myskiplsn)
 	{
-		bool		nulls[Natts_pg_subscription];
-		bool		replaces[Natts_pg_subscription];
-		Datum		values[Natts_pg_subscription];
-
-		memset(values, 0, sizeof(values));
-		memset(nulls, false, sizeof(nulls));
-		memset(replaces, false, sizeof(replaces));
+		Bitmapset  *updated = NULL;
 
 		/* reset subskiplsn */
-		values[Anum_pg_subscription_subskiplsn - 1] = LSNGetDatum(InvalidXLogRecPtr);
-		replaces[Anum_pg_subscription_subskiplsn - 1] = true;
-
-		tup = heap_modify_tuple(tup, RelationGetDescr(rel), values, nulls,
-								replaces);
-		CatalogTupleUpdate(rel, &tup->t_self, tup);
+		HeapTupleUpdateField(pg_subscription, subskiplsn, LSNGetDatum(InvalidXLogRecPtr), subform, updated);
+		CatalogTupleUpdate(rel, &tup->t_self, tup, updated, NULL);
+		bms_free(updated);
 
 		if (myskiplsn != finish_lsn)
 			ereport(WARNING,
diff --git a/src/backend/rewrite/rewriteDefine.c b/src/backend/rewrite/rewriteDefine.c
index 6a223fbeaa4..121910b005e 100644
--- a/src/backend/rewrite/rewriteDefine.c
+++ b/src/backend/rewrite/rewriteDefine.c
@@ -59,8 +59,8 @@ InsertRule(const char *rulname,
 {
 	char	   *evqual = nodeToString(event_qual);
 	char	   *actiontree = nodeToString((Node *) action);
-	Datum		values[Natts_pg_rewrite];
-	bool		nulls[Natts_pg_rewrite] = {0};
+	Datum		values[Natts_pg_rewrite] = {0};
+	bool		nulls[Natts_pg_rewrite] = {false};
 	NameData	rname;
 	Relation	pg_rewrite_desc;
 	HeapTuple	tup,
@@ -69,18 +69,19 @@ InsertRule(const char *rulname,
 	ObjectAddress myself,
 				referenced;
 	bool		is_update = false;
+	Bitmapset  *updated = NULL;
 
 	/*
 	 * Set up *nulls and *values arrays
 	 */
 	namestrcpy(&rname, rulname);
-	values[Anum_pg_rewrite_rulename - 1] = NameGetDatum(&rname);
-	values[Anum_pg_rewrite_ev_class - 1] = ObjectIdGetDatum(eventrel_oid);
-	values[Anum_pg_rewrite_ev_type - 1] = CharGetDatum(evtype + '0');
-	values[Anum_pg_rewrite_ev_enabled - 1] = CharGetDatum(RULE_FIRES_ON_ORIGIN);
-	values[Anum_pg_rewrite_is_instead - 1] = BoolGetDatum(evinstead);
-	values[Anum_pg_rewrite_ev_qual - 1] = CStringGetTextDatum(evqual);
-	values[Anum_pg_rewrite_ev_action - 1] = CStringGetTextDatum(actiontree);
+	HeapTupleUpdateValue(pg_rewrite, rulename, NameGetDatum(&rname), values, nulls, updated);
+	HeapTupleUpdateValue(pg_rewrite, ev_class, ObjectIdGetDatum(eventrel_oid), values, nulls, updated);
+	HeapTupleUpdateValue(pg_rewrite, ev_type, CharGetDatum(evtype + '0'), values, nulls, updated);
+	HeapTupleUpdateValue(pg_rewrite, ev_enabled, CharGetDatum(RULE_FIRES_ON_ORIGIN), values, nulls, updated);
+	HeapTupleUpdateValue(pg_rewrite, is_instead, BoolGetDatum(evinstead), values, nulls, updated);
+	HeapTupleUpdateValue(pg_rewrite, ev_qual, CStringGetTextDatum(evqual), values, nulls, updated);
+	HeapTupleUpdateValue(pg_rewrite, ev_action, CStringGetTextDatum(actiontree), values, nulls, updated);
 
 	/*
 	 * Ready to store new pg_rewrite tuple
@@ -96,8 +97,6 @@ InsertRule(const char *rulname,
 
 	if (HeapTupleIsValid(oldtup))
 	{
-		bool		replaces[Natts_pg_rewrite] = {0};
-
 		if (!replace)
 			ereport(ERROR,
 					(errcode(ERRCODE_DUPLICATE_OBJECT),
@@ -107,16 +106,14 @@ InsertRule(const char *rulname,
 		/*
 		 * When replacing, we don't need to replace every attribute
 		 */
-		replaces[Anum_pg_rewrite_ev_type - 1] = true;
-		replaces[Anum_pg_rewrite_is_instead - 1] = true;
-		replaces[Anum_pg_rewrite_ev_qual - 1] = true;
-		replaces[Anum_pg_rewrite_ev_action - 1] = true;
-
-		tup = heap_modify_tuple(oldtup, RelationGetDescr(pg_rewrite_desc),
-								values, nulls, replaces);
-
-		CatalogTupleUpdate(pg_rewrite_desc, &tup->t_self, tup);
-
+		HeapTupleUpdateValue(pg_rewrite, ev_type, CharGetDatum(evtype + '0'), values, nulls, updated);
+		HeapTupleUpdateValue(pg_rewrite, is_instead, BoolGetDatum(evinstead), values, nulls, updated);
+		HeapTupleUpdateValue(pg_rewrite, ev_qual, CStringGetTextDatum(evqual), values, nulls, updated);
+		HeapTupleUpdateValue(pg_rewrite, ev_action, CStringGetTextDatum(actiontree), values, nulls, updated);
+
+		tup = heap_update_tuple(oldtup, RelationGetDescr(pg_rewrite_desc),
+								values, nulls, updated);
+		CatalogTupleUpdate(pg_rewrite_desc, &tup->t_self, tup, updated, NULL);
 		ReleaseSysCache(oldtup);
 
 		rewriteObjectId = ((Form_pg_rewrite) GETSTRUCT(tup))->oid;
@@ -127,14 +124,12 @@ InsertRule(const char *rulname,
 		rewriteObjectId = GetNewOidWithIndex(pg_rewrite_desc,
 											 RewriteOidIndexId,
 											 Anum_pg_rewrite_oid);
-		values[Anum_pg_rewrite_oid - 1] = ObjectIdGetDatum(rewriteObjectId);
-
+		HeapTupleUpdateValue(pg_rewrite, oid, ObjectIdGetDatum(rewriteObjectId), values, nulls, updated);
 		tup = heap_form_tuple(pg_rewrite_desc->rd_att, values, nulls);
-
-		CatalogTupleInsert(pg_rewrite_desc, tup);
+		CatalogTupleInsert(pg_rewrite_desc, tup, NULL);
 	}
 
-
+	bms_free(updated);
 	heap_freetuple(tup);
 
 	/* If replacing, get rid of old dependencies and make new ones */
@@ -727,8 +722,11 @@ EnableDisableRule(Relation rel, const char *rulename,
 	 */
 	if (ruleform->ev_enabled != fires_when)
 	{
-		ruleform->ev_enabled = fires_when;
-		CatalogTupleUpdate(pg_rewrite_desc, &ruletup->t_self, ruletup);
+		Bitmapset  *updated = NULL;
+
+		HeapTupleUpdateField(pg_rewrite, ev_enabled, fires_when, ruleform, updated);
+		CatalogTupleUpdate(pg_rewrite_desc, &ruletup->t_self, ruletup, updated, NULL);
+		bms_free(updated);
 
 		changed = true;
 	}
@@ -799,6 +797,7 @@ RenameRewriteRule(RangeVar *relation, const char *oldName,
 	Form_pg_rewrite ruleform;
 	Oid			ruleOid;
 	ObjectAddress address;
+	Bitmapset  *updated = NULL;
 
 	/*
 	 * Look up name, check permissions, and acquire lock (which we will NOT
@@ -845,8 +844,9 @@ RenameRewriteRule(RangeVar *relation, const char *oldName,
 
 	/* OK, do the update */
 	namestrcpy(&(ruleform->rulename), newName);
-
-	CatalogTupleUpdate(pg_rewrite_desc, &ruletup->t_self, ruletup);
+	HeapTupleMarkColumnUpdated(pg_rewrite, rulename, updated);
+	CatalogTupleUpdate(pg_rewrite_desc, &ruletup->t_self, ruletup, updated, NULL);
+	bms_free(updated);
 
 	InvokeObjectPostAlterHook(RewriteRelationId, ruleOid, 0);
 
diff --git a/src/backend/rewrite/rewriteSupport.c b/src/backend/rewrite/rewriteSupport.c
index fffded88a6e..be6fcfd6dcb 100644
--- a/src/backend/rewrite/rewriteSupport.c
+++ b/src/backend/rewrite/rewriteSupport.c
@@ -18,6 +18,7 @@
 #include "access/table.h"
 #include "catalog/indexing.h"
 #include "catalog/pg_class.h"
+#include "nodes/bitmapset.h"
 #include "catalog/pg_rewrite.h"
 #include "rewrite/rewriteSupport.h"
 #include "utils/inval.h"
@@ -68,9 +69,12 @@ SetRelationRuleStatus(Oid relationId, bool relHasRules)
 	if (classForm->relhasrules != relHasRules)
 	{
 		/* Do the update */
+		Bitmapset  *updated = NULL;
+
 		classForm->relhasrules = relHasRules;
+		updated = bms_add_member(updated, Anum_pg_class_relhasrules - FirstLowInvalidHeapAttributeNumber);
 
-		CatalogTupleUpdate(relationRelation, &tuple->t_self, tuple);
+		CatalogTupleUpdate(relationRelation, &tuple->t_self, tuple, updated, NULL);
 	}
 	else
 	{
diff --git a/src/backend/statistics/extended_stats.c b/src/backend/statistics/extended_stats.c
index b9a8f257042..b0ae54add5d 100644
--- a/src/backend/statistics/extended_stats.c
+++ b/src/backend/statistics/extended_stats.c
@@ -762,20 +762,14 @@ statext_store(Oid statOid, bool inh,
 {
 	Relation	pg_stextdata;
 	HeapTuple	stup;
-	Datum		values[Natts_pg_statistic_ext_data];
-	bool		nulls[Natts_pg_statistic_ext_data];
+	Datum		values[Natts_pg_statistic_ext_data] = {0};
+	bool		nulls[Natts_pg_statistic_ext_data] = {false};
 
 	pg_stextdata = table_open(StatisticExtDataRelationId, RowExclusiveLock);
 
-	memset(nulls, true, sizeof(nulls));
-	memset(values, 0, sizeof(values));
-
 	/* basic info */
-	values[Anum_pg_statistic_ext_data_stxoid - 1] = ObjectIdGetDatum(statOid);
-	nulls[Anum_pg_statistic_ext_data_stxoid - 1] = false;
-
-	values[Anum_pg_statistic_ext_data_stxdinherit - 1] = BoolGetDatum(inh);
-	nulls[Anum_pg_statistic_ext_data_stxdinherit - 1] = false;
+	HeapTupleSetValue(pg_statistic_ext_data, stxoid, ObjectIdGetDatum(statOid), values);
+	HeapTupleSetValue(pg_statistic_ext_data, stxdinherit, BoolGetDatum(inh), values);
 
 	/*
 	 * Construct a new pg_statistic_ext_data tuple, replacing the calculated
@@ -785,29 +779,42 @@ statext_store(Oid statOid, bool inh,
 	{
 		bytea	   *data = statext_ndistinct_serialize(ndistinct);
 
-		nulls[Anum_pg_statistic_ext_data_stxdndistinct - 1] = (data == NULL);
-		values[Anum_pg_statistic_ext_data_stxdndistinct - 1] = PointerGetDatum(data);
+		if (data == NULL)
+			HeapTupleSetValueNull(pg_statistic_ext_data, stxdndistinct, values, nulls);
+		else
+			HeapTupleSetValue(pg_statistic_ext_data, stxdndistinct, PointerGetDatum(data), values);
 	}
+	else
+		HeapTupleSetValueNull(pg_statistic_ext_data, stxdndistinct, values, nulls);
 
 	if (dependencies != NULL)
 	{
 		bytea	   *data = statext_dependencies_serialize(dependencies);
 
-		nulls[Anum_pg_statistic_ext_data_stxddependencies - 1] = (data == NULL);
-		values[Anum_pg_statistic_ext_data_stxddependencies - 1] = PointerGetDatum(data);
+		if (data == NULL)
+			HeapTupleSetValueNull(pg_statistic_ext_data, stxddependencies, values, nulls);
+		else
+			HeapTupleSetValue(pg_statistic_ext_data, stxddependencies, PointerGetDatum(data), values);
 	}
+	else
+		HeapTupleSetValueNull(pg_statistic_ext_data, stxddependencies, values, nulls);
+
 	if (mcv != NULL)
 	{
 		bytea	   *data = statext_mcv_serialize(mcv, stats);
 
-		nulls[Anum_pg_statistic_ext_data_stxdmcv - 1] = (data == NULL);
-		values[Anum_pg_statistic_ext_data_stxdmcv - 1] = PointerGetDatum(data);
+		if (data == NULL)
+			HeapTupleSetValueNull(pg_statistic_ext_data, stxdmcv, values, nulls);
+		else
+			HeapTupleSetValue(pg_statistic_ext_data, stxdmcv, PointerGetDatum(data), values);
 	}
+	else
+		HeapTupleSetValueNull(pg_statistic_ext_data, stxdmcv, values, nulls);
+
 	if (exprs != (Datum) 0)
-	{
-		nulls[Anum_pg_statistic_ext_data_stxdexpr - 1] = false;
-		values[Anum_pg_statistic_ext_data_stxdexpr - 1] = exprs;
-	}
+		HeapTupleSetValue(pg_statistic_ext_data, stxdexpr, exprs, values);
+	else
+		HeapTupleSetValueNull(pg_statistic_ext_data, stxdexpr, values, nulls);
 
 	/*
 	 * Delete the old tuple if it exists, and insert a new one. It's easier
@@ -817,7 +824,7 @@ statext_store(Oid statOid, bool inh,
 
 	/* form and insert a new tuple */
 	stup = heap_form_tuple(RelationGetDescr(pg_stextdata), values, nulls);
-	CatalogTupleInsert(pg_stextdata, stup);
+	CatalogTupleInsert(pg_stextdata, stup, NULL);
 
 	heap_freetuple(stup);
 
@@ -2292,8 +2299,8 @@ serialize_expr_stats(AnlExprData *exprdata, int nexprs)
 					k;
 		VacAttrStats *stats = exprdata[exprno].vacattrstat;
 
-		Datum		values[Natts_pg_statistic];
-		bool		nulls[Natts_pg_statistic];
+		Datum		values[Natts_pg_statistic] = {0};
+		bool		nulls[Natts_pg_statistic] = {false};
 		HeapTuple	stup;
 
 		if (!stats->stats_valid)
@@ -2314,12 +2321,12 @@ serialize_expr_stats(AnlExprData *exprdata, int nexprs)
 			nulls[i] = false;
 		}
 
-		values[Anum_pg_statistic_starelid - 1] = ObjectIdGetDatum(InvalidOid);
-		values[Anum_pg_statistic_staattnum - 1] = Int16GetDatum(InvalidAttrNumber);
-		values[Anum_pg_statistic_stainherit - 1] = BoolGetDatum(false);
-		values[Anum_pg_statistic_stanullfrac - 1] = Float4GetDatum(stats->stanullfrac);
-		values[Anum_pg_statistic_stawidth - 1] = Int32GetDatum(stats->stawidth);
-		values[Anum_pg_statistic_stadistinct - 1] = Float4GetDatum(stats->stadistinct);
+		HeapTupleSetValue(pg_statistic, starelid, ObjectIdGetDatum(InvalidOid), values);
+		HeapTupleSetValue(pg_statistic, staattnum, Int16GetDatum(InvalidAttrNumber), values);
+		HeapTupleSetValue(pg_statistic, stainherit, BoolGetDatum(false), values);
+		HeapTupleSetValue(pg_statistic, stanullfrac, Float4GetDatum(stats->stanullfrac), values);
+		HeapTupleSetValue(pg_statistic, stawidth, Int32GetDatum(stats->stawidth), values);
+		HeapTupleSetValue(pg_statistic, stadistinct, Float4GetDatum(stats->stadistinct), values);
 		i = Anum_pg_statistic_stakind1 - 1;
 		for (k = 0; k < STATISTIC_NUM_SLOTS; k++)
 		{
diff --git a/src/backend/statistics/relation_stats.c b/src/backend/statistics/relation_stats.c
index d6631e9a9a4..5a7904ee1a2 100644
--- a/src/backend/statistics/relation_stats.c
+++ b/src/backend/statistics/relation_stats.c
@@ -18,6 +18,7 @@
 #include "postgres.h"
 
 #include "access/heapam.h"
+#include "access/htup.h"
 #include "catalog/indexing.h"
 #include "catalog/namespace.h"
 #include "nodes/makefuncs.h"
@@ -79,10 +80,9 @@ relation_statistics_update(FunctionCallInfo fcinfo)
 	bool		update_relallfrozen = false;
 	HeapTuple	ctup;
 	Form_pg_class pgcform;
-	int			replaces[4] = {0};
-	Datum		values[4] = {0};
-	bool		nulls[4] = {0};
-	int			nreplaces = 0;
+	Datum		values[Natts_pg_class] = {0};
+	bool		nulls[Natts_pg_class] = {false};
+	Bitmapset  *updated = NULL;
 	Oid			locked_table = InvalidOid;
 
 	stats_check_required_arg(fcinfo, relarginfo, RELSCHEMA_ARG);
@@ -146,42 +146,26 @@ relation_statistics_update(FunctionCallInfo fcinfo)
 	pgcform = (Form_pg_class) GETSTRUCT(ctup);
 
 	if (update_relpages && relpages != pgcform->relpages)
-	{
-		replaces[nreplaces] = Anum_pg_class_relpages;
-		values[nreplaces] = UInt32GetDatum(relpages);
-		nreplaces++;
-	}
+		HeapTupleUpdateValue(pg_class, relpages, UInt32GetDatum(relpages), values, nulls, updated);
 
 	if (update_reltuples && reltuples != pgcform->reltuples)
-	{
-		replaces[nreplaces] = Anum_pg_class_reltuples;
-		values[nreplaces] = Float4GetDatum(reltuples);
-		nreplaces++;
-	}
+		HeapTupleUpdateValue(pg_class, reltuples, Float4GetDatum(reltuples), values, nulls, updated);
 
 	if (update_relallvisible && relallvisible != pgcform->relallvisible)
-	{
-		replaces[nreplaces] = Anum_pg_class_relallvisible;
-		values[nreplaces] = UInt32GetDatum(relallvisible);
-		nreplaces++;
-	}
+		HeapTupleUpdateValue(pg_class, relallvisible, UInt32GetDatum(relallvisible), values, nulls, updated);
 
 	if (update_relallfrozen && relallfrozen != pgcform->relallfrozen)
-	{
-		replaces[nreplaces] = Anum_pg_class_relallfrozen;
-		values[nreplaces] = UInt32GetDatum(relallfrozen);
-		nreplaces++;
-	}
+		HeapTupleUpdateValue(pg_class, relallfrozen, UInt32GetDatum(relallfrozen), values, nulls, updated);
 
-	if (nreplaces > 0)
+	if (!bms_is_empty(updated))
 	{
 		TupleDesc	tupdesc = RelationGetDescr(crel);
 		HeapTuple	newtup;
 
-		newtup = heap_modify_tuple_by_cols(ctup, tupdesc, nreplaces,
-										   replaces, values, nulls);
-		CatalogTupleUpdate(crel, &newtup->t_self, newtup);
+		newtup = heap_update_tuple(ctup, tupdesc, values, nulls, updated);
+		CatalogTupleUpdate(crel, &newtup->t_self, newtup, updated, NULL);
 		heap_freetuple(newtup);
+		bms_free(updated);
 	}
 
 	ReleaseSysCache(ctup);
diff --git a/src/backend/storage/large_object/inv_api.c b/src/backend/storage/large_object/inv_api.c
index 466c1a856cb..e442a1ca549 100644
--- a/src/backend/storage/large_object/inv_api.c
+++ b/src/backend/storage/large_object/inv_api.c
@@ -562,9 +562,8 @@ inv_write(LargeObjectDesc *obj_desc, const char *buf, int nbytes)
 	}			workbuf = {0};
 	char	   *workb = VARDATA(&workbuf.hdr);
 	HeapTuple	newtup;
-	Datum		values[Natts_pg_largeobject];
-	bool		nulls[Natts_pg_largeobject];
-	bool		replace[Natts_pg_largeobject];
+	Datum		values[Natts_pg_largeobject] = {0};
+	bool		nulls[Natts_pg_largeobject] = {false};
 	CatalogIndexState indstate;
 
 	Assert(obj_desc);
@@ -610,6 +609,8 @@ inv_write(LargeObjectDesc *obj_desc, const char *buf, int nbytes)
 
 	while (nwritten < nbytes)
 	{
+		Bitmapset  *updated = NULL;
+
 		/*
 		 * If possible, get next pre-existing page of the LO.  We expect the
 		 * indexscan will deliver these in order --- but there may be holes.
@@ -665,16 +666,11 @@ inv_write(LargeObjectDesc *obj_desc, const char *buf, int nbytes)
 			/*
 			 * Form and insert updated tuple
 			 */
-			memset(values, 0, sizeof(values));
-			memset(nulls, false, sizeof(nulls));
-			memset(replace, false, sizeof(replace));
-			values[Anum_pg_largeobject_data - 1] = PointerGetDatum(&workbuf);
-			replace[Anum_pg_largeobject_data - 1] = true;
-			newtup = heap_modify_tuple(oldtuple, RelationGetDescr(lo_heap_r),
-									   values, nulls, replace);
-			CatalogTupleUpdateWithInfo(lo_heap_r, &newtup->t_self, newtup,
-									   indstate);
+			HeapTupleUpdateValue(pg_largeobject, data, PointerGetDatum(&workbuf), values, nulls, updated);
+			newtup = heap_update_tuple(oldtuple, RelationGetDescr(lo_heap_r), values, nulls, updated);
+			CatalogTupleUpdate(lo_heap_r, &newtup->t_self, newtup, updated, indstate);
 			heap_freetuple(newtup);
+			bms_free(updated);
 
 			/*
 			 * We're done with this old page.
@@ -711,11 +707,11 @@ inv_write(LargeObjectDesc *obj_desc, const char *buf, int nbytes)
 			 */
 			memset(values, 0, sizeof(values));
 			memset(nulls, false, sizeof(nulls));
-			values[Anum_pg_largeobject_loid - 1] = ObjectIdGetDatum(obj_desc->id);
-			values[Anum_pg_largeobject_pageno - 1] = Int32GetDatum(pageno);
-			values[Anum_pg_largeobject_data - 1] = PointerGetDatum(&workbuf);
+			HeapTupleSetValue(pg_largeobject, loid, ObjectIdGetDatum(obj_desc->id), values);
+			HeapTupleSetValue(pg_largeobject, pageno, Int32GetDatum(pageno), values);
+			HeapTupleSetValue(pg_largeobject, data, PointerGetDatum(&workbuf), values);
 			newtup = heap_form_tuple(lo_heap_r->rd_att, values, nulls);
-			CatalogTupleInsertWithInfo(lo_heap_r, newtup, indstate);
+			CatalogTupleInsert(lo_heap_r, newtup, indstate);
 			heap_freetuple(newtup);
 		}
 		pageno++;
@@ -751,9 +747,9 @@ inv_truncate(LargeObjectDesc *obj_desc, int64 len)
 	}			workbuf = {0};
 	char	   *workb = VARDATA(&workbuf.hdr);
 	HeapTuple	newtup;
-	Datum		values[Natts_pg_largeobject];
-	bool		nulls[Natts_pg_largeobject];
-	bool		replace[Natts_pg_largeobject];
+	Datum		values[Natts_pg_largeobject] = {0};
+	bool		nulls[Natts_pg_largeobject] = {false};
+	Bitmapset  *updated = NULL;
 	CatalogIndexState indstate;
 
 	Assert(obj_desc);
@@ -840,14 +836,11 @@ inv_truncate(LargeObjectDesc *obj_desc, int64 len)
 		 */
 		memset(values, 0, sizeof(values));
 		memset(nulls, false, sizeof(nulls));
-		memset(replace, false, sizeof(replace));
-		values[Anum_pg_largeobject_data - 1] = PointerGetDatum(&workbuf);
-		replace[Anum_pg_largeobject_data - 1] = true;
-		newtup = heap_modify_tuple(oldtuple, RelationGetDescr(lo_heap_r),
-								   values, nulls, replace);
-		CatalogTupleUpdateWithInfo(lo_heap_r, &newtup->t_self, newtup,
-								   indstate);
+		HeapTupleUpdateValue(pg_largeobject, data, PointerGetDatum(&workbuf), values, nulls, updated);
+		newtup = heap_update_tuple(oldtuple, RelationGetDescr(lo_heap_r), values, nulls, updated);
+		CatalogTupleUpdate(lo_heap_r, &newtup->t_self, newtup, updated, indstate);
 		heap_freetuple(newtup);
+		bms_free(updated);
 	}
 	else
 	{
@@ -879,11 +872,11 @@ inv_truncate(LargeObjectDesc *obj_desc, int64 len)
 		 */
 		memset(values, 0, sizeof(values));
 		memset(nulls, false, sizeof(nulls));
-		values[Anum_pg_largeobject_loid - 1] = ObjectIdGetDatum(obj_desc->id);
-		values[Anum_pg_largeobject_pageno - 1] = Int32GetDatum(pageno);
-		values[Anum_pg_largeobject_data - 1] = PointerGetDatum(&workbuf);
+		HeapTupleSetValue(pg_largeobject, loid, ObjectIdGetDatum(obj_desc->id), values);
+		HeapTupleSetValue(pg_largeobject, pageno, Int32GetDatum(pageno), values);
+		HeapTupleSetValue(pg_largeobject, data, PointerGetDatum(&workbuf), values);
 		newtup = heap_form_tuple(lo_heap_r->rd_att, values, nulls);
-		CatalogTupleInsertWithInfo(lo_heap_r, newtup, indstate);
+		CatalogTupleInsert(lo_heap_r, newtup, indstate);
 		heap_freetuple(newtup);
 	}
 
diff --git a/src/backend/utils/cache/relcache.c b/src/backend/utils/cache/relcache.c
index 6b634c9fff1..61d6c8f669c 100644
--- a/src/backend/utils/cache/relcache.c
+++ b/src/backend/utils/cache/relcache.c
@@ -3775,6 +3775,7 @@ RelationSetNewRelfilenumber(Relation relation, char persistence)
 	MultiXactId minmulti = InvalidMultiXactId;
 	TransactionId freezeXid = InvalidTransactionId;
 	RelFileLocator newrlocator;
+	Bitmapset  *updated = NULL;
 
 	if (!IsBinaryUpgrade)
 	{
@@ -3924,21 +3925,21 @@ RelationSetNewRelfilenumber(Relation relation, char persistence)
 	else
 	{
 		/* Normal case, update the pg_class entry */
-		classform->relfilenode = newrelfilenumber;
+		HeapTupleUpdateField(pg_class, relfilenode, newrelfilenumber, classform, updated);
 
 		/* relpages etc. never change for sequences */
 		if (relation->rd_rel->relkind != RELKIND_SEQUENCE)
 		{
-			classform->relpages = 0;	/* it's empty until further notice */
-			classform->reltuples = -1;
-			classform->relallvisible = 0;
-			classform->relallfrozen = 0;
+			HeapTupleUpdateField(pg_class, relpages, 0, classform, updated);
+			HeapTupleUpdateField(pg_class, reltuples, -1, classform, updated);
+			HeapTupleUpdateField(pg_class, relallvisible, 0, classform, updated);
+			HeapTupleUpdateField(pg_class, relallfrozen, 0, classform, updated);
 		}
-		classform->relfrozenxid = freezeXid;
-		classform->relminmxid = minmulti;
-		classform->relpersistence = persistence;
+		HeapTupleUpdateField(pg_class, relfrozenxid, freezeXid, classform, updated);
+		HeapTupleUpdateField(pg_class, relminmxid, minmulti, classform, updated);
+		HeapTupleUpdateField(pg_class, relpersistence, persistence, classform, updated);
 
-		CatalogTupleUpdate(pg_class, &otid, tuple);
+		CatalogTupleUpdate(pg_class, &otid, tuple, updated, NULL);
 	}
 
 	UnlockTuple(pg_class, &otid, InplaceUpdateTupleLock);
@@ -3953,6 +3954,7 @@ RelationSetNewRelfilenumber(Relation relation, char persistence)
 	CommandCounterIncrement();
 
 	RelationAssumeNewRelfilelocator(relation);
+	bms_free(updated);
 }
 
 /*
-- 
2.51.2

